package org.grouplens.common.test.impl;

import org.hamcrest.BaseMatcher;
import org.hamcrest.Description;

import java.util.Collection;

/**
 * Matcher for collections containing an object. We should pull this from hamcrest-library,
 * but JUnit issues prevent that.
 * @author Michael Ekstrand
 * @since 0.6
 */
public class ContainsMatcher<T> extends BaseMatcher<Collection<?>> {
    T element;

    public ContainsMatcher(T obj) {
        element = obj;
    }

    @Override
    public boolean matches(Object o) {
        try {
            Collection<?> foo = (Collection) o;
            return foo.contains(element);
        } catch (ClassCastException e) {
            return false;
        }
    }

    @Override
    public void describeTo(Description description) {
        description.appendText("collection containing ").appendValue(element);
    }
}
